/*
Game notes.
The game is ran using three primary functions. RenderGame(), ProcGame(), ProcInput().

RenderGame() does the drawing of the game.

ProcGame() handles the processing of ships, ai, projectiles, the level, etc

ProcInput() handles the processing of the player's input.

The game is based around a few objects. The first is the Player one, this contains the 
player's ship, scores, color, and so forth.

 The second is the enemy array that contains enemy
objects. enemy objects consist of what AI, ship, shields, color, position and so forth.

The level object contains the levels propertys, enemy types (all enemys are copys of one 
'main' version of that enemy), events (the order in which the level executes), etc. 

The projectile object contains arrays of three types of projectiles: bullets, effects, and
items. Bullets are what ships hit each other with, effects are for making the game look
preety, and items are things the player can touch.

The AI objects are part of the 'main' version of the enemys, and contain the patterns for
them to follow.

These and other misc objects combine with the three primary funtions to create the game.
*/

var edge_timer = 0
var in_edge = false

function RenderGame()
{
	rest = false
	if (GetTime() > next_update[0]) 
	{
		rest = true		
	}
	
	for (var i = 0; i < level.background.img.length; i++)
		{

			if (rest == true) level.background.position[i] = level.background.position[i]+level.background.speed[i]			
			if (level.background.position[i] >= 240) { level.background.position[i] = 0 }
			if (ComplexBG == true || i == 0)
				{
					level.background.img[i].blit(0,-240+level.background.position[i])
					level.background.img[i].blit(0,level.background.position[i])
				}
		}
	
	if (rest == true ) next_update[0] = GetTime() + update_rate[0];			

	if (dead == true) font.drawText(90,105,"Press enter to restart")
	font.drawText(5,225,"[Projectiles:"+Projectiles.length+"]")
	if (in_edge == true)
		{
			font.drawText(90,105,"GET OFF OF EDGE! ")
			font.drawText(95,95,edge_timer+"/50")
		}
	for (var i = 0; i < Enemys.length; i++)
		{
			if (Enemys[i].color == 0)
				{
					Ship_ImageA[Enemys[i].sprite].blit(Enemys[i].x,Enemys[i].y)
				}
			else
				{
					Ship_ImageB[Enemys[i].sprite].blit(Enemys[i].x,Enemys[i].y)
				}
			for (var i2 = 0; i2 < Enemys[i].point_xy.length; i2++)
				{
					particles[Enemys[i].point_obj[i2]].img.blit(Enemys[i].point_xy[i2][0]+Enemys[i].x-8,Enemys[i].point_xy[i2][1]+Enemys[i].y-8)
				}		
		}			
	for (var i = 0; i < Players.length; i++)
		{
			particles[1].img.blit(10,10+(i*15))
			particles[2].img.blit(70,10+(i*15))		
			font.drawText(25,10+(i*15),Players[i].red)
			font.drawText(85,10+(i*15),Players[i].green)
			font.drawText(130,10+(i*15),"*"+Players[i].shields)
			font.drawText(170,10+(i*15),"$"+Players[i].money)

			if (Players[i].color == 0)
				{
					Ship_ImageA[Players[i].sprite].blit(Players[i].x,Players[i].y)
				}
			else
				{
					Ship_ImageB[Players[i].sprite].blit(Players[i].x,Players[i].y)
				}
			for (var i2 = 0; i2 < Players[i].point_obj.length; i2++)
				{
					particles[Players[i].point_obj[i2]].img.blit(Players[i].point_xy[i2][0]+Players[i].x-8,Players[i].point_xy[i2][1]+Players[i].y-8)
					if (i2 == 0) font.drawText(Players[i].point_xy[i2][0]+Players[i].x-10,Players[i].point_xy[i2][1]+Players[i].y-8,i2)
				}	
		}	
	for (var i = 0; i < Projectiles.length; i++)
		{
			if (Projectiles[i].props[0] != 1) projectile_imgs[Projectiles[i].sprite].blit(Projectiles[i].x,Projectiles[i].y)
			else 
				{
					projectile_imgs[Projectiles[i].sprite].rotateBlit(Projectiles[i].x,Projectiles[i].y,Projectiles[i].props[1])
					Projectiles[i].props[1] += .02
				}
		}	
}

function ProcInput()
{
	if (GetTime() > next_update[2])
		{
			if (dead == true && Players.length == 0 && IsKeyPressed(KEY_ENTER)) 
				{
					ProcList = new Array(); 
					ProcList.push(Reload);
				}
			for (var i = 0; i < Players.length; i++)
				{
					for (var i2 = 0; i2 < Players[i].point_obj.length; i2++)
						{				
							if (Players[i].delay[i2] < particles[Players[i].point_obj[i2]].delay)
								{
									Players[i].delay[i2]++;
									
								}
						}
					if (Players[i].odelay[0] < 15) { Players[i].odelay[0]++; }
					if (IsKeyPressed(Players[i].key.up) == true)
						{
							Players[i].y -= 4;
						}
					if (IsKeyPressed(Players[i].key.down) == true)
						{
							Players[i].y += 4;
						}
					if (IsKeyPressed(Players[i].key.left) == true)
						{
							Players[i].x -= 4;
						}
					if (IsKeyPressed(Players[i].key.right) == true)
						{
							Players[i].x += 4;
						}
					if (IsKeyPressed(Players[i].key.fire) == true)
						{
							for (var i2 = 0; i2 < Players[i].point_obj.length; i2++)
								{
									if (Players[i].delay[i2] >= particles[Players[i].point_obj[i2]].delay)
										{
											FireParticle(i,i2,0)
											Players[i].delay[i2] = 0
											//PlaySound(RandomShot(),Random(0.5,1))
										}
								}
									
							//Projectiles.push(new Projectile(50,140,0,3,2,1,0,2,[]))
						}
					if (IsKeyPressed(Players[i].key.change) == true && Players[i].odelay[0] == 15)
						{
							if (Players[i].color == 0) { Players[i].color = 1; }
							else { Players[i].color = 0; }
							Players[i].odelay[0] = 0;
						}
					if (IsKeyPressed(Players[i].key.rotate) == true && Players[i].odelay[0] == 15)
						{
							a = Players[i].point_obj.pop()				
							Players[i].point_obj.unshift(a)
							Players[i].odelay[0] = 0;
						}
					if (IsKeyPressed(Players[i].key.build) == true && Players[i].odelay[0] == 15)
						{
							BuildParticle(i)
							Players[i].odelay[0] = 0;
						}
					if (IsKeyPressed(KEY_P))
						{
							background = GrabImage(0, 0, GetScreenWidth(), GetScreenHeight());
							ProcList = new Array()
							while (!IsKeyPressed(KEY_ENTER))
								{
									background.blit(0,0);	
									font.drawText(90,105,"PRESS ENTER TO CONTINUE")				
									FlipScreen();
								}
							ProcList.push(RenderGame)
							ProcList.push(ProcInput)
							ProcList.push(ProcGame)								
						}
				}
			next_update[2] = GetTime() + update_rate[2];			
		}

}

function ProcGame()
{
	if (GetTime() > next_update[4])
		{
			ProcAI()
			ProcProjectiles()
			ProcLevel()
			for (var i = 0; i < Players.length; i++)
				{
					if (Players[i].x < 0 || Players[i].x+Ship_ImageA[Players[i].sprite].width > 320 || Players[i].y < 0 || Players[i].y+Ship_ImageA[Players[i].sprite].height > 240)
						{
							in_edge = true;
						}
					else { in_edge = false }	
					if (edge_timer >= 50)
					{
						if (Players[i].color == 0) DamagePlayer(i,1,1)
						else { DamagePlayer(i,1,0) }				
					}
					if (edge_timer < 50) CollisionDetect(i)					
				}
			if (Players.length <= 0)
				{
					in_edge = false
					edge_timer = 0
				}
			if (in_edge == false && edge_timer > 0)
				{
					edge_timer -= .5
				}
			if (in_edge == true) { edge_timer++; }	
			next_update[4] = GetTime() + update_rate[4];
		}
}

function ProcAI()
{
	for (var i = 0; i < Enemys.length; i++)
		{
			if (Enemys[i].ai_adelay < AI_LIST[Enemys[i].ai].actions[Enemys[i].ai_action].delay)
				{
					Enemys[i].ai_adelay++;
				}
			if (Enemys[i].ai_adelay >= AI_LIST[Enemys[i].ai].actions[Enemys[i].ai_action].delay)
				{
					ExecuteActionScript(AI_LIST[Enemys[i].ai].actions[Enemys[i].ai_action].act,AI_LIST[Enemys[i].ai].actions[Enemys[i].ai_action].prop,i)
					Enemys[i].ai_adelay = 0
				}
			if (Enemys[i].x < AI_LIST[Enemys[i].ai].points[Enemys[i].ai_point].x-Enemys[i].speed)
			 { Enemys[i].x += Enemys[i].speed; }
			else
				{
					if (Enemys[i].x > AI_LIST[Enemys[i].ai].points[Enemys[i].ai_point].x+Enemys[i].speed) 
					{ Enemys[i].x -= Enemys[i].speed; }
				}
			if (Enemys[i].y < AI_LIST[Enemys[i].ai].points[Enemys[i].ai_point].y-Enemys[i].speed) 
			 { Enemys[i].y += Enemys[i].speed; }
			else
				{
					if (Enemys[i].y > AI_LIST[Enemys[i].ai].points[Enemys[i].ai_point].y+Enemys[i].speed) 
					{ Enemys[i].y -= Enemys[i].speed; }
				}
			kill = false
			if (Enemys[i].x >= AI_LIST[Enemys[i].ai].points[Enemys[i].ai_point].x-Enemys[i].speed &&
					Enemys[i].x <= AI_LIST[Enemys[i].ai].points[Enemys[i].ai_point].x+Enemys[i].speed &&
					Enemys[i].y >= AI_LIST[Enemys[i].ai].points[Enemys[i].ai_point].y-Enemys[i].speed &&
					Enemys[i].y <= AI_LIST[Enemys[i].ai].points[Enemys[i].ai_point].y+Enemys[i].speed)
						{

							if (Enemys[i].ai_point >= AI_LIST[Enemys[i].ai].points.length-1 || Enemys[i].ai_order == 1 && Enemys[i].ai_point == 0)
								{
									kill = false
									if (AI_LIST[Enemys[i].ai].loop == 0)
										{
											Enemys.splice(i,1)
											kill = true
										}
									else
										{
											if (Enemys[i].ai_order == 0)
												{
													Enemys[i].ai_order = 1
												}
											else
												{
													Enemys[i].ai_order = 0
												}	
										}
								}
							if (kill == false)
								{
									if (Enemys[i].ai_order == 0 && Enemys[i].ai_point < AI_LIST[Enemys[i].ai].points.length-1) Enemys[i].ai_point++
									else { Enemys[i].ai_point--; }
									ExecuteActionScript(AI_LIST[Enemys[i].ai].points[Enemys[i].ai_point].onPoint,AI_LIST[Enemys[i].ai].points[Enemys[i].ai_point].onPointProp,i)
								}
								
						}
			//if (Enemys[i].newai != false) { Enemys[i].ai = Enemys[i].newai; Enemys[i].newai = false }			
					
		}
}

function FireParticle(i,i2,player_or_enemy)
{
	if (player_or_enemy == 0)
		{
			if (Players[i].point_obj[i2] != 0) PlaySound(RandomShot(),Random(0.5,1))
			switch (Players[i].point_obj[i2])
				{
					case 0:
															
					break;
					case 1:
						Projectiles.push(new Projectile(
						/*X:*/Players[i].point_xy[i2][0]+Players[i].x+Random(-2,2)-8,
						/*Y:*/Players[i].point_xy[i2][1]+Players[i].y+Random(-2,2)-8,
						/*Move Type:*/0,
						/*Sprite:*/2+Players[i].color,
						/*Group:*/0,
						/*Type:*/0,
						/*OnTouch:*/1,
						/*Speed:*/4,
						/*Props:*/[],
						/*Color:*/Players[i].color))
					break;
					case 2:
						Projectiles.push(new Projectile(
						/*X:*/Players[i].point_xy[i2][0]+Players[i].x+Random(-2,2)-8,
						/*Y:*/Players[i].point_xy[i2][1]+Players[i].y+Random(-2,2)-8,
						/*Move Type:*/4,
						/*Sprite:*/4+Players[i].color,
						/*Group:*/0,
						/*Type:*/0,
						/*OnTouch:*/1.1,
						/*Speed:*/5,
						/*Props:*/[],
						/*Color:*/Players[i].color))					
					break;
					case 6:
						Projectiles.push(new Projectile(
						/*X:*/Players[i].point_xy[i2][0]+Players[i].x+Random(-2,2)-8,
						/*Y:*/Players[i].point_xy[i2][1]+Players[i].y+Random(-2,2)-8,
						/*Move Type:*/6,
						/*Sprite:*/10+Players[i].color,
						/*Group:*/0,
						/*Type:*/0,
						/*OnTouch:*/5,
						/*Speed:*/10,
						/*Props:*/[],
						/*Color:*/Players[i].color))							
					break;
					case 5:
						Projectiles.push(new Projectile(
						/*X:*/Players[i].point_xy[i2][0]+Players[i].x+Random(-2,2)-8,
						/*Y:*/Players[i].point_xy[i2][1]+Players[i].y+Random(-2,2)-8,
						/*Move Type:*/0,
						/*Sprite:*/2+Players[i].color,
						/*Group:*/0,
						/*Type:*/0,
						/*OnTouch:*/1,
						/*Speed:*/4,
						/*Props:*/[],
						/*Color:*/Players[i].color))
						Projectiles.push(new Projectile(
						/*X:*/Players[i].point_xy[i2][0]+Players[i].x+Random(-2,2)-8,
						/*Y:*/Players[i].point_xy[i2][1]+Players[i].y+Random(-2,2)-8,
						/*Move Type:*/1,
						/*Sprite:*/2+Players[i].color,
						/*Group:*/0,
						/*Type:*/0,
						/*OnTouch:*/1,
						/*Speed:*/4,
						/*Props:*/[],
						/*Color:*/Players[i].color))
						Projectiles.push(new Projectile(
						/*X:*/Players[i].point_xy[i2][0]+Players[i].x+Random(-2,2)-8,
						/*Y:*/Players[i].point_xy[i2][1]+Players[i].y+Random(-2,2)-8,
						/*Move Type:*/2,
						/*Sprite:*/2+Players[i].color,
						/*Group:*/0,
						/*Type:*/0,
						/*OnTouch:*/1,
						/*Speed:*/4,
						/*Props:*/[],
						/*Color:*/Players[i].color))
						Projectiles.push(new Projectile(
						/*X:*/Players[i].point_xy[i2][0]+Players[i].x+Random(-2,2)-8,
						/*Y:*/Players[i].point_xy[i2][1]+Players[i].y+Random(-2,2)-8,
						/*Move Type:*/3,
						/*Sprite:*/2+Players[i].color,
						/*Group:*/0,
						/*Type:*/0,
						/*OnTouch:*/1,
						/*Speed:*/4,
						/*Props:*/[],
						/*Color:*/Players[i].color))																		
					
					break;
					case 3:
						for (var i2 = 0; i2 < Random(0,2); i2++)
							{
								Projectiles.push(new Projectile(
								/*X:*/Players[i].point_xy[i2][0]+Players[i].x+Random(-2,2)-8,
								/*Y:*/Players[i].point_xy[i2][1]+Players[i].y+Random(-2,2)-8,
								/*Move Type:*/Random(0,3),
								/*Sprite:*/12+Players[i].color,
								/*Group:*/0,
								/*Type:*/0,
								/*OnTouch:*/Random(1,5),
								/*Speed:*/Random(3,5),
								/*Props:*/[1,0],
								/*Color:*/Players[i].color))
							}					
					break;
					case 4:
						for (var i2 = 0; i2 < 4; i2++)
							{					
								Projectiles.push(new Projectile(
								/*X:*/Players[i].point_xy[i2][0]+Players[i].x+Random(-2,2)-8,
								/*Y:*/Players[i].point_xy[i2][1]+Players[i].y+Random(-2,2)-8,
								/*Move Type:*/4,
								/*Sprite:*/4+Players[i].color,
								/*Group:*/0,
								/*Type:*/0,
								/*OnTouch:*/.3,
								/*Speed:*/5,
								/*Props:*/[],
								/*Color:*/Players[i].color))
							}						
					break;
					
				}
		}
	else
		{
			if (Enemys[i].point_obj[i2] != 0) PlaySound(RandomShot(),Random(0.5,1))
			switch (Enemys[i].point_obj[i2])
				{
					case 0:
															
					break;
					case 1:
						Projectiles.push(new Projectile(
						/*X:*/Enemys[i].point_xy[i2][0]+Enemys[i].x+Random(-2,2)-8,
						/*Y:*/Enemys[i].point_xy[i2][1]+Enemys[i].y+Random(-2,2)-8,
						/*Move type:*/1,
						/*Sprite:*/2+Enemys[i].color,
						/*Group:*/1,
						/*Type:*/0,
						/*OnTouch:*/1,
						/*Speed:*/4,
						/*Props:*/[],
						/*Color:*/Enemys[i].color))
					break;
					case 2:
						Projectiles.push(new Projectile(
						/*X:*/Enemys[i].point_xy[i2][0]+Enemys[i].x+Random(-2,2)-8,
						/*Y:*/Enemys[i].point_xy[i2][1]+Enemys[i].y+Random(-2,2)-8,
						/*Move type:*/5,
						/*Sprite:*/4+Enemys[i].color,
						/*Group:*/1,
						/*Type:*/0,
						/*OnTouch:*/1.1,
						/*Speed:*/5,
						/*Props:*/[],
						/*Color:*/Enemys[i].color))					
					break;
					case 6:
						Projectiles.push(new Projectile(
						/*X:*/Enemys[i].point_xy[i2][0]+Enemys[i].x+Random(-2,2)-8,
						/*Y:*/Enemys[i].point_xy[i2][1]+Enemys[i].y+Random(-2,2)-8,
						/*Move Type:*/7,
						/*Sprite:*/10+Enemys[i].color,
						/*Group:*/1,
						/*Type:*/0,
						/*OnTouch:*/4,
						/*Speed:*/10,
						/*Props:*/[],
						/*Color:*/Enemys[i].color))						
					break;
					case 5:
						Projectiles.push(new Projectile(
						/*X:*/Enemys[i].point_xy[i2][0]+Enemys[i].x+Random(-2,2)-8,
						/*Y:*/Enemys[i].point_xy[i2][1]+Enemys[i].y+Random(-2,2)-8,
						/*Move type:*/0,
						/*Sprite:*/2+Enemys[i].color,
						/*Group:*/1,
						/*Type:*/0,
						/*OnTouch:*/1,
						/*Speed:*/4,
						/*Props:*/[],
						/*Color:*/Enemys[i].color))		
						Projectiles.push(new Projectile(
						/*X:*/Enemys[i].point_xy[i2][0]+Enemys[i].x+Random(-2,2)-8,
						/*Y:*/Enemys[i].point_xy[i2][1]+Enemys[i].y+Random(-2,2)-8,
						/*Move type:*/1,
						/*Sprite:*/2+Enemys[i].color,
						/*Group:*/1,
						/*Type:*/0,
						/*OnTouch:*/1,
						/*Speed:*/4,
						/*Props:*/[],
						/*Color:*/Enemys[i].color))		
						Projectiles.push(new Projectile(
						/*X:*/Enemys[i].point_xy[i2][0]+Enemys[i].x+Random(-2,2)-8,
						/*Y:*/Enemys[i].point_xy[i2][1]+Enemys[i].y+Random(-2,2)-8,
						/*Move type:*/2,
						/*Sprite:*/2+Enemys[i].color,
						/*Group:*/1,
						/*Type:*/0,
						/*OnTouch:*/1,
						/*Speed:*/4,
						/*Props:*/[],
						/*Color:*/Enemys[i].color))		
						Projectiles.push(new Projectile(
						/*X:*/Enemys[i].point_xy[i2][0]+Enemys[i].x+Random(-2,2)-8,
						/*Y:*/Enemys[i].point_xy[i2][1]+Enemys[i].y+Random(-2,2)-8,
						/*Move type:*/3,
						/*Sprite:*/2+Enemys[i].color,
						/*Group:*/1,
						/*Type:*/0,
						/*OnTouch:*/1,
						/*Speed:*/4,
						/*Props:*/[],
						/*Color:*/Enemys[i].color))																							
					break;
					case 3:
						for (var i2 = 0; i2 < Random(0,2); i2++)
							{
								Projectiles.push(new Projectile(
								/*X:*/Enemys[i].point_xy[i2][0]+Enemys[i].x+Random(-2,2)-8,
								/*Y:*/Enemys[i].point_xy[i2][1]+Enemys[i].y+Random(-2,2)-8,
								/*Move Type:*/Random(0,3),
								/*Sprite:*/12+Enemys[i].color,
								/*Group:*/1,
								/*Type:*/0,
								/*OnTouch:*/Random(1,5),
								/*Speed:*/Random(3,5),
								/*Props:*/[1,0],
								/*Color:*/Enemys[i].color))
							}					
					break;
					case 4:
						for (var i2 = 0; i2 < 4; i2++)
							{
								Projectiles.push(new Projectile(
								/*X:*/Enemys[i].point_xy[i2][0]+Enemys[i].x+Random(-2,2)-8,
								/*Y:*/Enemys[i].point_xy[i2][1]+Enemys[i].y+Random(-2,2)-8,
								/*Move type:*/5,
								/*Sprite:*/4+Enemys[i].color,
								/*Group:*/1,
								/*Type:*/0,
								/*OnTouch:*/.3,
								/*Speed:*/5,
								/*Props:*/[],
								/*Color:*/Enemys[i].color))								
							}					
					break;					
				}		
		}
}

function BuildParticle(p)
{
if (Players[p].red >= 10 && Players[p].green >= 10)
	{
		
		possible = []
		limit = 6
		particle = 0
		
		for (var i = 1; Players[p].red+Players[p].green >= 20*i; i++)
			{
				particle++;
			}
			
		if (particle >= limit) { particle = limit; }	

		Players[p].red = 0
		Players[p].green = 0
		done = false
		
		i = 0
		
		while (i < Players[p].point_obj.length && done == false)
			{
				if (Players[p].point_obj[i] == 0)
					{
						Players[p].point_obj[i] = particle
						done = true
					}
				i++
			}
		if (done == false)
			{
				Players[p].point_obj[0] = particle
			}
		PlaySound("beep.wav",Random(.5,1))	
	}		
}

function CollisionDetect(p)
{
	for (var i = 0; i < Enemys.length; i++)
		{
			if ( 
					Enemys[i].x <= Ship_ImageA[Players[p].sprite].width+Players[p].x &&
					Enemys[i].x+Ship_ImageA[Enemys[i].sprite].width >= Players[p].x &&
					Enemys[i].y+Ship_ImageA[Enemys[i].sprite].height >= Players[p].y &&
					Enemys[i].y <= Players[p].y+Ship_ImageA[Players[p].sprite].height 
				 )
					{
						if (Players[p].color == 0) DamagePlayer(p,1,1)
						else { DamagePlayer(p,1,0) }
						return
					}
		}
}	